@ adf.prc     JSH 10/13/90
   computes adf t-statistics for cointegrating regression
@
proc (1)=adf_reg(z,nfirst,nlast,ilag);
 local *;
 dz_0=z[nfirst:nlast,1]-z[(nfirst-1):(nlast-1),.];
 z1_1=z[(nfirst-1):(nlast-1),1];
 xz=z1_1;
 if ilag>0;
  i=1; do until i>ilag;
   xz=xz~(z[(nfirst-i):(nlast-i),1]-z[(nfirst-i-1):(nlast-i-1),1]);
  i=i+1; endo;
 endif;
 xz=xz~ones(rows(xz),1);
 xxi=inv(xz'*xz); b=xxi*(xz'*dz_0);
 e=dz_0-xz*b; s2=(e'e)/(rows(e)-cols(xz));
 tdf=b[1,1]/sqrt(s2*xxi[1,1]);

retp(tdf|(1+b[1,1]));
endp;
@----------------------------------------------------------------@
proc (0)=adf(y,x,nfirst,nlast,nlag);

local *;
xxt=ones(rows(x),1)~x~seqa(1,1,rows(x));

y1=y[nfirst:nlast,1];
@ residual from CI regression including constant: @
 x1=xxt[nfirst:nlast,1:(cols(xxt)-1)];
 b1=inv(x1'*x1)*(x1'*y1);
 z1=y-xxt[.,1:(cols(xxt)-1)]*b1;

@ residual from CI regression including constant and time @
 x2=xxt[nfirst:nlast,1:cols(xxt)];
 b2=inv(x2'*x2)*(x2'*y1);
 z2=y-xxt*b2;
 " ";
 "------ ADF t-statistics from cointegrating regression: -------- ";
 "***** NOTE: Demeaned stats only valid if data was not previously detrended";
 " ";"nfirst, nlast: ";; format /RDN 6,0; nfirst nlast;
 " ";"Static OLS coefficients, including constant:";
 format /RDN 10,4; b1';
 " ";"static OLS coefficients, augmented by time coefficient";
 b2';" ";
 " --------------- RESIDUAL-BASED ADF TEST STATISTICS --------------";" ";
 "                            demeaned               detrended ";
 "         No. lags       t-stat    rhohat       t-stat     rhohat";

@ compute, report adf statistics @
ilag=0; do until ilag>nlag;
 tdf1=adf_reg(z1,nfirst,nlast,ilag);
 tdf2=adf_reg(z2,nfirst,nlast,ilag);
 "      ";;format /RDN 8,0; ilag "     ";;
 format /RDN 10,3; tdf1' "    " tdf2';
ilag=ilag+1; endo;
" ";
endp;
@----------------------------------------------------------------@
proc (1)=adf_fix(y,x,nf,nl,nlag,b);
 local *;
 z=y-x*b;
 " ";" -- RESIDUAL-BASED ADF TEST STATISTICS: fixed Cointegrating vector --";
  format /RDN 10,4;" Cointegrating vector: " b';" ";
 "                            demeaned ";
 "         No. lags       t-stat    rhohat   Stdc(z)";
 ilag=0; do until ilag>nlag;
  tdf1=adf_reg(z,nf,nl,ilag);
  out9=tdf1|stdc(z[nf:nl,.]);
 "      ";;format /RDN 8,0; ilag "     ";;
 format /RDN 10,3; out9';
 ilag=ilag+1; endo;
retp(out9);
endp;

/*
@ debug @
@x=cumsumc(rndn(100,2)); y=x*(1|1)+(rndn(100,1));
@
@adf(y,x,7,100,5);@
adf_fix(y,x,nf,nl,nlag,1|-.01);
*/

