/* JOH_lf.PRC   mww, mod. jhs 10/12/90
  returns value of VECM (Johansen) likelihood
       for computation of Johansen MLE
*/

proc joh_lf(zm,nfirst,nlast,nlag,b);
 local *;
 dz=zeros(1,cols(zm))|(zm[2:rows(zm),.]-zm[1:(rows(zm)-1),.]);
 ec = zm*(1|(-b));
 y = dz[nfirst:nlast,.];
 x = ones(rows(y),1);
 x = x~ec[nfirst-1:nlast-1,.];
 i=1; do while i <= nlag;
  x=x~dz[nfirst-i:nlast-i,.];
 i=i+1; endo;
 bet=invpd(x'x)*(x'y);
 eps=y-x*bet;
 seps=eps'eps/(rows(eps));

 lf=zeros(rows(eps),1);
 sepsi=invpd(seps);
 lnds=ln(det(seps));
 t=1; do while t <= rows(eps);
   lf[t,1]=-0.5*(lnds + eps[t,.]*sepsi*eps[t,.]');
 t=t+1; endo;

retp(sumc(lf));
endp;

/*
@ debugging @
joh_lf(zm,nf,nl,2,(-1.238)|.181);
*/


