@ nlls.prc     JHS 1/7/90
   computes nlls estimator of cointegrating vector, including a constant
   in the regression

Input:
   y = y data              Tx1
   x = x data (levels of ) Txk
   nfirst = first obs of y and x to use in regression
   nlast = last obs of y and x to use in regression
   nlag = number of lags of delta x to use in regression
          (notice that lags include values of x before nfirst)

   Output:
   bNLLS == normalized NLLS cointegrating vector estimator
@
proc (1)=nlls(y,x,nfirst,nlast,nlag);
 local *;
 @ SOLS estimate @
  xz=x[nfirst:nlast,.]~ones(nlast-nfirst+1,1);
  bSOLS=inv(xz'xz)*xz'y[nfirst:nlast,1];
  bSOLS=1.00|(-bSOLS[1:cols(x),.]);
@ NLLS estimate @
 z=y~x; k=cols(z);
 y_0=y[nfirst:nlast,.]-y[(nfirst-1):(nlast-1),.];
 z1_1=z[(nfirst-1):(nlast-1),.];
 xz=z1_1~ones(rows(z1_1),1);
 if nlag>0;
  i=1; do until i>nlag;
   xz=xz~(z[(nfirst-i):(nlast-i),.]-z[(nfirst-i-1):(nlast-i-1),.]);
  i=i+1; endo;
 endif;
 xxi=inv(xz'*xz); b=xxi*(xz'*y_0);
 e=y_0-xz*b; s2=(e'e)/(rows(e)-cols(xz));
 BNLLSNN=b[1:k,.];
 bNLLS=1|(b[2:k,1]/b[1,1]);
 format /RDN 9,4;
 " ";" ------- SOLS, NLLS Cointegrating Vector estimates --------";
 "   SOLS                    ";;bSOLS';
 "   NLLS -- non-normalized: ";;bNLLSNN';
 "   NLLS -- normalized:     ";;bNLLS';

retp(-bNLLS[2:rows(bnlls),1]);
endp;

/*
@ debug @
nobs=200;x=cumsumc(rndn(nobs,2)); y=x*(1|1)+(rndn(nobs,1));
nlls(y,x,7,nobs,2);
*/

