@ SOLS_LF.prc    computes value of ssr from static OLS regression
   modification of DOLS_LF.prc  JHS 10/14/90
@
proc (1) = sols_lf(y,x,nfirst,nlast,nlag,b);
/*
   This procedure estimates model with a constant via OLS.
    The model is augmented with leads and lags of delta x
    The covariance matrix is calculated robustly (serial cor).
    It calculates Beta, tstat, and two Wald test statistics

Input:
y = y data              Tx1
x = x data (levels of ) Txk
nfirst = first obs of y and x to use in regression
nlast = last obs of y and x to use in regression
nlag = number of lags of delta x to use in regression
       (notice that lags include values of x before nfirst)
*/

local *;
ya=y[nfirst:nlast,.]-x[nfirst:nlast,.]*b;
e=ya-meanc(ya);
s2=(e'e)/rows(e);
ssr=-rows(e)*ln(sqrt(s2));

 @ calculate tdf statistic for residuals, rhohat @
tdfrho=adf_reg(e,nlag+2,rows(e),nlag);

retp(ssr|tdfrho);
endp;

/*
@ debug: @
sols_lf(y,x,nf,nl,nlag,(1|-.01));
*/

